#pragma once

#include <string>
#include <queue>
#include "runner.hpp" 

namespace sk {
class host {
    std::string ip;

    unsigned int connections;
    unsigned int connectionsMax;

    std::queue<sk::runner> runners;

  public:
    host(const std::string &ip, unsigned int connectionsMax);
    void addConnection(sk::runner& runner);

    const std::string &getIp() const;

    unsigned int getNbConnections() const;
    unsigned int getNbConnectionsMax() const;

    bool operator<(const host &other) const {
        return (connectionsMax - connections) <
               other.getNbConnectionsMax() - other.getNbConnections();
    }
};
}
